var ec2ui_ElasticIPTreeView = {
    COLNAMES : ['eip.address','eip.instanceid'],
    treeBox : null,
    selection : null,
    arrLocalFiles : new Array,
    eipList : new Array(),
    registered : false,

    get rowCount() { return this.eipList.length; },

    setTree     : function(treeBox)         { this.treeBox = treeBox; },
    getCellText : function(idx, column) {
       if (idx >= this.rowCount) return "";
       return eval("this.eipList[idx]."+column.id.split(".").pop());
    },
    isEditable: function(idx, column)  { return true; },
    isContainer: function(idx)         { return false;},
    isSeparator: function(idx)         { return false; },
    isSorted: function()               { return false; },
    
    getImageSrc: function(idx, column) { return ""; },
    getProgressMode : function(idx,column) {},
    getCellValue: function(idx, column) {},
    cycleHeader: function(col) {
       cycleHeader(
         col, 
         document, 
         this.COLNAMES, 
         this.eipList);
    },

    sort : function() {
       sortView(document, this.COLNAMES, this.eipList);
    },

    selectionChanged: function() {},
    cycleCell: function(idx, column) {},
    performAction: function(action) {},
    performActionOnCell: function(action, index, column) {},
    getRowProperties: function(idx, column, prop) {},
    getCellProperties: function(idx, column, prop) {},
    getColumnProperties: function(column, element, prop) {},
    getLevel : function(idx) { return 0; },

    register: function() {
        if (!this.registered) {
            this.registered = true;
            ec2ui_model.registerInterest(this, 'addresses');
        }
    },

    invalidate: function() {
        this.displayEIPs(ec2ui_session.model.addresses);
    },
    
    refresh: function() {
        ec2ui_session.controller.describeAddresses();
    },

    notifyModelChanged: function(interest) {
        this.invalidate();
    },

    viewDetails : function(event) {
       var selected = new Array();
       for(var i in this.eipList) {
          if (this.selection.isSelected(i)) {
             selected.push(this.eipList[i]);
          }
       }
       if (selected.length != 1) return;
       
       window.openDialog("chrome://ec2ui/content/dialog_eip_details.xul", null, "chrome,centerscreen,modal", selected[0]);
    },
    
    selectByAddress: function(address) {
       this.selection.clearSelection();
       for(var i in this.eipList) {
         if (this.eipList[i].address == address) {
             this.selection.select(i);
             return;
         }
       }
       
       // In case we don't find a match (which is probably a bug).
       this.selection.select(0);
    },

    getSelectedEip : function() {
       var index =  this.selection.currentIndex;
       if (index == -1) return null;
       return this.eipList[this.selection.currentIndex];
    },
    
    allocateAddress : function() {
       var me = this;
       var wrap = function(address) { 
         if (ec2ui_prefs.isRefreshOnChangeEnabled()) { 
             me.refresh();
             me.selectByAddress(address);
         }
       }
       ec2ui_session.controller.allocateAddress(wrap);
    },
    
    releaseAddress : function() {
       var eip = this.getSelectedEip();
       if (eip == null) return;
       var confirmed = confirm("Release "+eip.address+"?");
       if (!confirmed)
           return;
       
       var me = this;
       var wrap = function() { 
           if (ec2ui_prefs.isRefreshOnChangeEnabled()) { 
               me.refresh(); 
           }
       }
       ec2ui_session.controller.releaseAddress(eip.address, wrap);
    },
    
    associateAddress : function() {
       var eip = this.getSelectedEip();
       if (eip == null) return;
       if (eip.instanceid != null && eip.instanceid != '') {
           var confirmed = confirm("Address "+eip.address+" is already mapped to an instance, are you sure?");
           if (!confirmed)
               return;
       }
       var instanceid = prompt("Which instance ID would you like to associate "+eip.address+" with?");
       if (instanceid == null) return;

       var me = this;
       var wrap = function() { 
           if (ec2ui_prefs.isRefreshOnChangeEnabled()) { 
               me.refresh(); 
               me.selectByAddress(eip.address);
           }
       }
       ec2ui_session.controller.associateAddress(eip.address, instanceid, wrap);
    },
    
    disassociateAddress : function() {
       var eip = this.getSelectedEip();
       if (eip == null) return;
       if (eip.instanceid == null || eip.instanceid == '') return;
       
       var confirmed = confirm("Disassociate "+eip.address+" and instance "+eip.instanceid+"?");
       if (!confirmed)
           return;
       
       var me = this;
       var wrap = function() { 
           if (ec2ui_prefs.isRefreshOnChangeEnabled()) { 
               me.refresh(); 
           }
       }
       ec2ui_session.controller.disassociateAddress(eip.address, wrap);
    },
    
    displayEIPs : function (eipList) {
       if (!eipList) { eipList = []; }

       this.treeBox.rowCountChanged(0, -this.eipList.length);
       this.eipList = eipList;
       this.treeBox.rowCountChanged(0, this.eipList.length);
       this.sort();
       this.selection.clearSelection();
       if (eipList.length > 0) {
           this.selection.select(0);
       }
    }
};

ec2ui_ElasticIPTreeView.register();
